#!/bin/zsh
# Copyright 2011 Paul Haensch
# This file is part of Busy
#
# Busy is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Busy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with Busy.  If not, see <http://www.gnu.org/licenses/>.

info="$(egrep -o '(^|&)i=[0-9]{10}_[0-9]{3}(&|$)' <<<"${QUERY_STRING}" |tr -d '&=i')"
[ -f "../Wiki/$info.lock" ] && rm "../Wiki/$info.lock"

if [ -n "${CONTENT_LENGTH}" -a "${CONTENT_LENGTH}" -gt 0 ]; then
(head -c "${CONTENT_LENGTH}"; echo)|sed 's/&/\n/g' |while read line; do
  if (echo "${line}" | egrep -xq 'page=.+'); then
    page="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    page=$(echo -e "${page}" |sed 's/\t/ /g;s/\r//g;s/\\/\\\\/g')
  elif (echo "${line}" | egrep -xq 'cancel=.+'); then
    cancel=true
  fi
done
fi

[ -z "$cancel" -a -f "../Wiki/$info" ] && mv "../Wiki/$info" "../Wiki/$info.$(date +%s)"
[ -z "$cancel" ] && echo -e "${page}" >"../Wiki/$info"

echo -n "Location: https://${HTTP_HOST}/?p=Wiki&i=$info\n\n"
